<?php
//--------------------------------------------------------------------
// *** RATEIT ***
// LAST UPDATE: 2009/05/30
// Version    : 1.31
// Copyright  : nJOY
// http://i-njoy.net/
//--------------------------------------------------------------------
//
// function.php
//
//--------------------------------------------------------------------

/* 評価を画像で表示 */
function blogn_mod_rateit_convert_average ($var) {
	$starf = '<img src="module/rateit/starf.gif" alt="" />';	// 1
	$starh = '<img src="module/rateit/starh.gif" alt="" />';	// 0.5
	$starn = '<img src="module/rateit/starn.gif" alt="" />';	// 0
	
	if ($var == 0) return "未評価";
	switch ($var) {
		case ($var >= 4.75):
			$str = $starf.$starf.$starf.$starf.$starf;
			break;
		case ($var >= 4.25):
			$str = $starf.$starf.$starf.$starf.$starh;
			break;
		case ($var >= 3.75):
			$str = $starf.$starf.$starf.$starf.$starn;
			break;
		case ($var >= 3.25):
			$str = $starf.$starf.$starf.$starh.$starn;
			break;
		case ($var >= 2.75):
			$str = $starf.$starf.$starf.$starn.$starn;
			break;
		case ($var >= 2.25):
			$str = $starf.$starf.$starh.$starn.$starn;
			break;
		case ($var >= 1.75):
			$str = $starf.$starf.$starn.$starn.$starn;
			break;
		case ($var >= 1.25):
			$str = $starf.$starh.$starn.$starn.$starn;
			break;
		default:
			$str = $starf.$starn.$starn.$starn.$starn;
			break;
	}
	return $str;
}

function blogn_mod_rateit_output($id) {
	$log = BLOGN_MODDIR.'rateit/log.cgi';
	$logdata = file($log);
	$count = count($logdata);
	$output = array(0,0);

	$i = 0;
	for ($i = 0; $i <= $count; $i++) {
		list($log_id, , , $log_number, $log_average, , ,) = explode(",", $logdata[$i]);
		if ($log_id == $id) {
			$output[0] = $log_average;
			$output[1] = $log_number;
			break;
		}
	}
	return $output;
}

function blogn_mod_rateit_log_today($logdata, $view, $number, $average) {
	$i = 0;
	$j = 0;
	$average = $average / 10;
	$logcount = count($logdata);
	$data = "";
	for ($i = 0; $i < $logcount; $i++) {
		$log = blogn_mod_db_log_load_for_editor($logdata[$i][0]);
		if ($log[0]) {
			if ($logdata[$i][3] >= $number && $logdata[$i][4] >= $average) {
				$data .= $logdata[$i][0].','.str_replace(",", "&#44;", $log[1]["title"]).','.$logdata[$i][2].','.$logdata[$i][3].','.$logdata[$i][4].",\r\n";
				$j += 1;
				if ($j >= $view) break;
			}
		} else {
			$data = "no data";
		}
	}
	return $data;
}

function blogn_mod_rateit_log_sort($logfile) {
	$logdata = file($logfile);
	$logcount = count($logdata);
	$i = 0;
	for ($i = 0; $i < $logcount; $i++) {
		$logdata[$i] = explode(",", $logdata[$i]);
	}
	usort($logdata, "cmp");
	return $logdata;
}

/* 評価データのソート */
function cmp($a, $b) {
	if ($a[4] > $b[4]) {
		return -1;
	} elseif ($a[4] < $b[4]) {
		return 1;
	} else {
		if ($a[3] > $b[3]) {
			return -1;
		} elseif ($a[3] < $b[3]) {
			return 1;
		} else {
			return 0;
		}
	}
}

/* ログファイル用日付取得 */
function blogn_mod_rateit_get_day($day) {
    return mktime(date("H"),date("i"),date("s"),date("m"),date("d")-$day,date("Y"));
}

/* スキン */
function blogn_mod_rateit_skin($user, $skin) {
	if (!strpos($skin, "{RATE}") || !strpos($skin, "{/RATE}")) return $skin;
	
	list($skin1,$buf,$skin2) = blogn_word_sepa("{RATELOOP}", "{/RATELOOP}", $skin);
	$skin3 = "";
	
	$i = 0;
	$rate_date0 = date("Ymd");
	$rate_file = BLOGN_MODDIR.'rateit/log/'.$rate_date0.'.log';
	if (file_exists($rate_file)) {
		$loglist = file($rate_file);
		$count = count($loglist);
		if ($count) {
			for ($i = 0; $i < $count; $i++) {
				list($RIid, $RItitle, $RItotal, $RInumber, $RIaverage) = explode(",", $loglist[$i]);
				$tmpbuf = $buf;
				$RIlink = '<a href="index.php?e='.$RIid.'">';
				$tmpbuf = preg_replace ("/\{RATE_TITLE\}/", $RItitle, $tmpbuf);
				$tmpbuf = preg_replace ("/\{RATE_LINK\}/", $RIlink, $tmpbuf);
				$tmpbuf = preg_replace ("/\{\/RATE_LINK\}/", '</a>', $tmpbuf);
				$tmpbuf = preg_replace ("/\{RATE_NO\}/", $RInumber, $tmpbuf);
				$tmpbuf = preg_replace ("/\{RATE_ST\}/", blogn_mod_rateit_convert_average($RIaverage), $tmpbuf);
				$skin3 .= $tmpbuf;
			}
			$skin = $skin1.$skin3.$skin2;
			$skin = preg_replace("/\{RATE\}/", "", $skin);
			$skin = preg_replace("/\{\/RATE\}/", "", $skin);
		} else {
			$skin = preg_replace("/\{RATE\}[\w\W]+?\{\/RATE\}/", "", $skin);
		}
	} else {
		$skin = preg_replace("/\{RATE\}[\w\W]+?\{\/RATE\}/", "", $skin);
	}
	return $skin;
}

?>
