<?php
//--------------------------------------------------------------------
// *** RATEIT ***
// LAST UPDATE: 2009/05/30
// Version    : 1.31
// Copyright  : nJOY
// http://i-njoy.net/
//--------------------------------------------------------------------
//
// rateit.php
//
//--------------------------------------------------------------------

if (@$_GET["mode"] == "rateit") {
	blogn_mod_rateit_send (@$_POST["id"], $blogn_server_remode_addr, @$_POST["rating"], @$_POST["cd"]);
	exit;
}

require BLOGN_MODDIR."rateit/function.php";

$blogn_skin = str_replace("{RATEIT_CD}", dechex(time()), $blogn_skin);

switch ($blogn_view_mode) {
	case "e":
		$blogn_mod_rateit_output = blogn_mod_rateit_output($blogn_get_e);
		$blogn_skin = str_replace("{RATEIT}", "", $blogn_skin);
		$blogn_skin = str_replace("{/RATEIT}", "", $blogn_skin);
		$blogn_skin = str_replace("{RATEIT_ID}", $blogn_get_e, $blogn_skin);
		$blogn_skin = str_replace("{RATEIT_ST}", blogn_mod_rateit_convert_average($blogn_mod_rateit_output[0]), $blogn_skin);
		$blogn_skin = str_replace("{RATEIT_NO}", $blogn_mod_rateit_output[1], $blogn_skin);
		break;
	default:
		$blogn_skin = preg_replace("/\{RATEIT\}[\w\W]+?\{\/RATEIT\}/", "", $blogn_skin);
		break;
}

$blogn_mod_rateit_date1 = date("Ymd", blogn_mod_rateit_get_day(1));
$blogn_mod_rateit_log1 = BLOGN_MODDIR.'rateit/log/'.$blogn_mod_rateit_date1.'.log';

if (file_exists($blogn_mod_rateit_log1)) {
	unlink($blogn_mod_rateit_log1);

	$blogn_mod_rateit_inifile = BLOGN_MODDIR.'rateit/config.cgi';
	$blogn_mod_rateit_inis = file($blogn_mod_rateit_inifile);
	$blogn_mod_rateit_rate = explode(",", $blogn_mod_rateit_inis[0]);

	$blogn_mod_rateit_logfile = BLOGN_MODDIR.'rateit/log.cgi';
	$blogn_mod_rateit_logdata = blogn_mod_rateit_log_sort($blogn_mod_rateit_logfile);
	$blogn_mod_rateit_logdata = blogn_mod_rateit_log_today($blogn_mod_rateit_logdata, $blogn_mod_rateit_rate[0], $blogn_mod_rateit_rate[1], $blogn_mod_rateit_rate[2]);

	$blogn_mod_rateit_rate_date0 = date("Ymd");
	$blogn_mod_rateit_rate_log0 = BLOGN_MODDIR.'rateit/log/'.$blogn_mod_rateit_rate_date0.'.log';

	$fp = @fopen($blogn_mod_rateit_rate_log0,"w") or die("Cannot Open File");
	flock($fp, LOCK_EX);
	fputs($fp, $blogn_mod_rateit_logdata);
	fclose($fp);
}

$blogn_skin = blogn_mod_rateit_skin($blogn_user, $blogn_skin);

//--------------------------------------------------------------------
function blogn_mod_rateit_send ($id, $ip, $rating, $display_time) {

	$submit_time = time();
	if (!$display_time || !preg_match("/^[0-9a-f]{8}$/", $display_time)) {
		$seconds = NULL;
	} else {
		$seconds = $submit_time - hexdec($display_time);
		if ($seconds < 0 || $seconds > 86400) $seconds = NULL;
	}

	if (!$id || !is_numeric($id) || !isset($ip) || !is_numeric($rating) || $seconds <= 5 || $rating > 5) {
		$link_url = BLOGN_HOMELINK."index.php";
		$refresh = "10";
		$info = 'エラー：記事の評価に失敗しました。<br /><br />画面が自動的に切り替わらない場合は<br><a href="'.$link_url.'">こちら</a>をクリックしてください。';
	} else {
		$logfile = BLOGN_MODDIR.'rateit/log.cgi';
		$link_url = BLOGN_HOMELINK."index.php?e=".$id;
		$logdata = file($logfile);
		$log_count = count($logdata);
		$refresh = "10";
	
		$i = 0;
		for ($i = 0; $i <= $log_count; $i++) {
			list($log_id, $log_ip, $log_rate, $number, $average) = explode(",", $logdata[$i]);
			if ($log_id == $id) {
				if ($log_ip == $ip) {
					$info = '<p><b>同じ記事の評価は１回までしかできません。</b></p><p>画面が自動的に切り替わらない場合は<br /><a href="'.$link_url.'">こちら</a>をクリックしてください。<p>';
					$flag = FALSE;
				} else {
					$rating += $log_rate;
					$number += 1;
					$average = round($rating / $number, 2);
					$new_record = "$id,$ip,$rating,$number,$average,,,\r\n";
					array_splice($logdata, $i, 1);
					$info = '<p><b>記事の評価、どうもありがとうございます。</b></p><p>画面が自動的に切り替わらない場合は<br /><a href="'.$link_url.'">こちら</a>をクリックしてください。</p>';
					$flag = TRUE;
				}
				break;
			} else {
				$new_record = "$id,$ip,$rating,1,$rating,,,\r\n";
				$info = '<p><b>記事の評価、どうもありがとうございます。</b></p><p>画面が自動的に切り替わらない場合は<br /><a href="'.$link_url.'">こちら</a>をクリックしてください。</p>';
				$flag = TRUE;
			}
		}
	
		if ($flag) {
			$lockfile = BLOGN_MODDIR.'rateit/lock';
			$lockfp = fopen($lockfile, "w");
			flock($lockfp, LOCK_EX);
			
			$fp = fopen($logfile, "w+");
			flock($fp, LOCK_EX);
			rewind($fp);
			foreach($logdata as $log) {
				fputs($fp, $log);
			}
			fputs($fp, $new_record);
			flock($fp, LOCK_UN);
			fclose($fp);
		
			flock($lockfp, LOCK_UN);
			fclose($lockfp);
		}
	}

	if (BLOGN_CHARSET == 0 || BLOGN_MOBILE_KEY == 1) {
		$charset = "Shift_JIS";
		$outkey = 2;
	} elseif (BLOGN_CHARSET == 1) {
		$charset = "EUC-JP";
		$outkey = 1;
	} elseif (BLOGN_CHARSET == 2) {
		$charset = "UTF-8";
		$outkey = 4;
	}

	$errdata = '
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="ja">
<head>
<meta http-equiv="refresh"content="'.$refresh.';URL='.$link_url.'">
<meta http-equiv=content-type content="text/html; charset='.$charset.'">
</head>
<body>
	
<div align="center">

<div style="text-align:center;border:1px solid;width:500px;padding:0.5em;">
'.$info.'
</div>

</div>
</body>
</html>';

	header("Content-Type: text/html; charset=$charset");
	if ($outkey != 4) $errdata = blogn_mbConv($errdata, 4, $outkey);
	if ($outkey == 2) $errdata = blogn_magic_quotes($errdata);
	echo $errdata;
	exit;
}


?>
